diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
index 1bc761e1a..265a7febd 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelVeryRotatable.java
@@ -7,41 +7,52 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicVeryRotatable;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.useless.dragonfly.DisplayPos;
 
 public class BlockModelVeryRotatable<T extends BlockLogic> extends BlockModelStandard<T> {
+    protected static final DisplayPos ROTATABLE_GUI = new DisplayPos(0, 0, 0, 30, 45, 0, 0.625f, 0.625f, 0.625f);
+    protected static final DisplayPos ROTATABLE_HEAD = new DisplayPos(0, 0, 0, 0, -180, 0, 1f, 1f, 1f);
+    protected static final DisplayPos ROTATABLE_FIRST_PERSON_RIGHT_HAND = new DisplayPos(0, 0, 0, 0, -45, 0, 0.4f, 0.4f, 0.4f);
+
     public BlockModelVeryRotatable(Block<T> block) {
         super(block);
+
+        setDisplayPos(DisplayPos.GUI, ROTATABLE_GUI);
+        setDisplayPos(DisplayPos.HEAD, ROTATABLE_HEAD);
+        setDisplayPos(DisplayPos.FIRST_PERSON_RIGHT_HAND, ROTATABLE_FIRST_PERSON_RIGHT_HAND);
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        final int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        final int meta = worldSource.getBlockMetadata(x, y, z);
         final Direction dir = BlockLogicVeryRotatable.metaToDirection(meta);
 
         if (dir == Direction.DOWN || dir == Direction.UP) {
             renderBlocks.uvRotateSouth = 1;
             renderBlocks.uvRotateNorth = 2;
         }
-        final boolean result = super.render(tessellator, x, y, z);
-        resetRenderBlocks();
+        final boolean result = super.render(tessellator, worldSource, x, y, z);
+        renderBlocks.resetRenderBlocks();
 
         return result;
     }
 
 
     @Override
-    public void renderBlockOnInventory(Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        super.renderBlockOnInventory(tessellator, 3, brightness, alpha, lightmapCoordinate);
+    public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
+        super.renderStandalone(tessellator, 3, brightness, alpha, lightmapCoordinate);
     }
 
     @Override
-    public IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data) {
+    public @Nullable IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data) {
         return super.getBlockOverbrightTextureFromSideAndMeta(getRotatedSide(side, data), data);
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
         return super.getBlockTextureFromSideAndMetadata(getRotatedSide(side, data), data);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
index 66d69aedf..9f53e013a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWireRedstone.java
@@ -10,6 +10,8 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicWireRedstone;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Color;
+import net.minecraft.core.world.WorldSource;
+import org.jetbrains.annotations.NotNull;
 
 public class BlockModelWireRedstone<T extends BlockLogic> extends BlockModelStandard<T> {
     protected final IconCoordinate wireStraight = TextureRegistry.getTexture("minecraft:block/wire_redstone_straight");
@@ -20,8 +22,8 @@ public class BlockModelWireRedstone<T extends BlockLogic> extends BlockModelStan
     }
 
     @Override
-    public boolean render(Tessellator tessellator, int x, int y, int z) {
-        int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+        int meta = worldSource.getBlockMetadata(x, y, z);
         IconCoordinate straight = wireStraight;
         IconCoordinate cross = wireCross;
         if(renderBlocks.overrideBlockTexture != null)
@@ -30,14 +32,14 @@ public class BlockModelWireRedstone<T extends BlockLogic> extends BlockModelStan
         }
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
-//            int lmc = block.getLightmapCoord(renderBlocks.blockAccess, x, y, z);
+//            int lmc = block.getLightmapCoord(worldSource, x, y, z);
 //            if(Blocks.lightEmission[block.id] > 0) {
 //                lmc = LightmapHelper.setBlocklightValue(lmc, 15);
 //            }
-            int lmc = LightmapHelper.getLightmapCoord(renderBlocks.blockAccess.getSavedLightValue(LightLayer.Sky, x, y, z), Math.max(renderBlocks.blockAccess.getSavedLightValue(LightLayer.Block, x, y, z), meta & 0xF));
+            int lmc = LightmapHelper.getLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, x, y, z), Math.max(worldSource.getSavedLightValue(LightLayer.Block, x, y, z), meta & 0xF));
             tessellator.setLightmapCoord(lmc);
         }else {
-            brightness = getBlockBrightness(renderBlocks.blockAccess, x, y, z);
+            brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
             if(block.emission > 0) {
                 brightness = 1.0f;
             }
@@ -51,32 +53,32 @@ public class BlockModelWireRedstone<T extends BlockLogic> extends BlockModelStan
         float blue = color.getBlue() / 255.0f;
 
         tessellator.setColorOpaque_F(brightness * red, brightness * green, brightness * blue);
-        boolean west = BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x - 1, y, z, 1) || !renderBlocks.blockAccess.isBlockNormalCube(x - 1, y, z) && BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x - 1, y - 1, z, -1);
-        boolean east = BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x + 1, y, z, 3) || !renderBlocks.blockAccess.isBlockNormalCube(x + 1, y, z) && BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x + 1, y - 1, z, -1);
-        boolean north = BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x, y, z - 1, 2) || !renderBlocks.blockAccess.isBlockNormalCube(x, y, z - 1) && BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x, y - 1, z - 1, -1);
-        boolean south = BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x, y, z + 1, 0) || !renderBlocks.blockAccess.isBlockNormalCube(x, y, z + 1) && BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x, y - 1, z + 1, -1);
+        boolean west = BlockLogicWireRedstone.shouldConnectTo(worldSource, x - 1, y, z, 1) || !worldSource.isBlockNormalCube(x - 1, y, z) && BlockLogicWireRedstone.shouldConnectTo(worldSource, x - 1, y - 1, z, -1);
+        boolean east = BlockLogicWireRedstone.shouldConnectTo(worldSource, x + 1, y, z, 3) || !worldSource.isBlockNormalCube(x + 1, y, z) && BlockLogicWireRedstone.shouldConnectTo(worldSource, x + 1, y - 1, z, -1);
+        boolean north = BlockLogicWireRedstone.shouldConnectTo(worldSource, x, y, z - 1, 2) || !worldSource.isBlockNormalCube(x, y, z - 1) && BlockLogicWireRedstone.shouldConnectTo(worldSource, x, y - 1, z - 1, -1);
+        boolean south = BlockLogicWireRedstone.shouldConnectTo(worldSource, x, y, z + 1, 0) || !worldSource.isBlockNormalCube(x, y, z + 1) && BlockLogicWireRedstone.shouldConnectTo(worldSource, x, y - 1, z + 1, -1);
         boolean westUp = false;
         boolean eastUp = false;
         boolean northUp = false;
         boolean southUp = false;
-        if(!renderBlocks.blockAccess.isBlockOpaqueCube(x, y + 1, z))
+        if(!worldSource.isBlockOpaqueCube(x, y + 1, z))
         {
-            if(renderBlocks.blockAccess.isBlockNormalCube(x - 1, y, z) && BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x - 1, y + 1, z, -1))
+            if(worldSource.isBlockNormalCube(x - 1, y, z) && BlockLogicWireRedstone.shouldConnectTo(worldSource, x - 1, y + 1, z, -1))
             {
                 west = true;
                 westUp = true;
             }
-            if(renderBlocks.blockAccess.isBlockNormalCube(x + 1, y, z) && BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x + 1, y + 1, z, -1))
+            if(worldSource.isBlockNormalCube(x + 1, y, z) && BlockLogicWireRedstone.shouldConnectTo(worldSource, x + 1, y + 1, z, -1))
             {
                 east = true;
                 eastUp = true;
             }
-            if(renderBlocks.blockAccess.isBlockNormalCube(x, y, z - 1) && BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x, y + 1, z - 1, -1))
+            if(worldSource.isBlockNormalCube(x, y, z - 1) && BlockLogicWireRedstone.shouldConnectTo(worldSource, x, y + 1, z - 1, -1))
             {
                 north = true;
                 northUp = true;
             }
-            if(renderBlocks.blockAccess.isBlockNormalCube(x, y, z + 1) && BlockLogicWireRedstone.shouldConnectTo(renderBlocks.blockAccess, x, y + 1, z + 1, -1))
+            if(worldSource.isBlockNormalCube(x, y, z + 1) && BlockLogicWireRedstone.shouldConnectTo(worldSource, x, y + 1, z + 1, -1))
             {
                 south = true;
                 southUp = true;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWool.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWool.java
index 6059031e9..8c00fc865 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWool.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelWool.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
+import org.jetbrains.annotations.Nullable;
 
 public class BlockModelWool<T extends BlockLogic> extends BlockModelStandard<T> {
     public static final IconCoordinate[] texCoords = new IconCoordinate[DyeColor.COLOR_AMOUNT];
@@ -20,7 +21,7 @@ public class BlockModelWool<T extends BlockLogic> extends BlockModelStandard<T>
     }
 
     @Override
-    public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
         return texCoords[data & DyeColor.MASK_COLOR];
     }
 }
